Index: /LMDZ5/branches/testing/DefLists/physiq.def_L39_AR40.0
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L39_AR40.0	(revision 2407)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L39_AR40.0	(revision 2408)
@@ -1,3 +1,6 @@
-##############################################################################
+#
+# $Id$
+#
+###############################################################################
 # PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
 ##############################################################################
Index: /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv0.0
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv0.0	(revision 2407)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv0.0	(revision 2408)
@@ -1,3 +1,6 @@
-##############################################################################
+#
+# $Id$
+#
+###############################################################################
 # PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
 ##############################################################################
Index: /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv1.0
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv1.0	(revision 2407)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv1.0	(revision 2408)
@@ -1,3 +1,6 @@
-##############################################################################
+#
+# $Id$
+#
+###############################################################################
 # PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
 ##############################################################################
Index: /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv2.0
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv2.0	(revision 2407)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv2.0	(revision 2408)
@@ -1,2 +1,5 @@
+#
+# $Id$
+#
 ##############################################################################
 # PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
Index: /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv3.0
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv3.0	(revision 2407)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L39_NPv3.0	(revision 2408)
@@ -1,3 +1,6 @@
-##############################################################################
+#
+# $Id$
+#
+###############################################################################
 # PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
 ##############################################################################
Index: /LMDZ5/branches/testing/DefLists/physiq.def_L59_NPv4.12
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L59_NPv4.12	(revision 2407)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L59_NPv4.12	(revision 2408)
@@ -1,3 +1,6 @@
-##############################################################################
+#
+# $Id$
+#
+###############################################################################
 # PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
 ##############################################################################
Index: /LMDZ5/branches/testing/DefLists/physiq.def_L79_NPv5.17h
===================================================================
--- /LMDZ5/branches/testing/DefLists/physiq.def_L79_NPv5.17h	(revision 2408)
+++ /LMDZ5/branches/testing/DefLists/physiq.def_L79_NPv5.17h	(revision 2408)
@@ -0,0 +1,181 @@
+#
+# $Id$
+#
+###############################################################################
+# PARAMETRES ET CLES DE LA PHYSIQUE LMDZ
+##############################################################################
+# D: Valeur par default
+#
+#Parametres Orographiques et cdrags
+#**********************************
+##   Si=.T. ,  lecture du fichier limit avec la bonne annee 
+ok_limitvrai=n
+iflag_albedo=1
+#Cdrags 
+f_cdrag_stable=1.
+f_cdrag_ter=1.
+f_cdrag_oce=0.7
+f_ri_cd_min=0.6
+#cdmmax
+cdmmax=2.5E-3
+#cdhmax
+cdhmax=2.0E-3
+##  Orodr  ou  non   pour l orographie
+ok_orodr=y
+##  Orolf  ou  non   pour l orographie              
+ok_orolf=y
+#Rugoro
+f_rugoro=0.
+#
+### Random gravity waves
+#Activitate the stochastic parameterization of convective GWs (should be equal to ok_strato)
+ok_gwd_rando=y
+# Scale the momentum fluxes due to convective GWs
+gwd_rando_ruwmax=2.5
+#Scale the saturated momentum flux of  convective GWs 
+gwd_rando_sat=0.2
+
+#
+# Rayonnement
+#*********************
+# activation du nouveau code de rayonnement RRTM
+# 0 : Ancien code et 1 : RRTM (D=0)
+iflag_rrtm=0
+#NSW=2
+#
+# Parametres nuages
+#******************
+#seuils de la precipitation des nuages strateformes (D: 2.6e-4 2.6e-4)
+cld_lc_lsc=0.0003
+cld_lc_con=0.0003
+#constante de temps pour eleminer eau lsc et convective (D: 3600. 3600.)
+cld_tau_lsc=1800.
+cld_tau_con=1800.
+#facteurs correctifs sur la vitesse de chute des cristaux de glace (D: 1 1)
+ffallv_lsc=0.66528
+ffallv_con=0.66528
+#coefficient sur la reevaporation de la pluie (D: 2.e-5 n)
+coef_eva=2e-5
+reevap_ice=y
+#calcul des proprietes des nuages convectifs (D:1 0.375 1.e-4) 
+iflag_cldcon=6
+fact_cldcon=1.
+facttemps=0.
+#calcul eau condensee et fraction nuageuse a partir des PDF (D:0, 0:version avec ratqs sinon nouvelles PDFs)  
+iflag_pdf=1
+#calcul epaisseur optique et emmissivite des nuages (D: y 1 0.01 0.3)
+ok_newmicro=y
+iflag_ratqs=4
+ratqsbas=0.002
+ratqshaut=0.312
+#rayon effectif pour les nuages de glace (D:35)
+rad_froid=35
+#rayons effectifs pour les nuages eau liq (tailles des gouttes d eau nuageuse, D: 13 9)
+rad_chau1=12
+rad_chau2=11
+##  Choix ou non  de  New oliq               
+new_oliq=y
+#Rayons min et max effectifs des particules des nuages
+rei_min=16.
+rei_max=61.29
+#
+# Flags Convection 
+#*****************
+#Convection scheme switch (D:2, 1:LMD, 2:Tiedtke, 3:KE New Physics, 30:KE AR4)
+iflag_con=3
+#output level of energy conservation diagnostics
+if_ebil=0
+#maximum efficiency of cld water->precipitation conversion (D: 0.993)
+epmax=0.998
+#dry convective adjustment at beginning of Emanuel convective scheme (D: n 0)
+ok_adj_ema=n
+iflag_clw=0
+#Convective closure (D:1, 0:AR4, 2:ALE and ALP)
+iflag_clos=2
+#Convective entrainment mixing law (D:1, 0:AR4=flat PDF, 1=PDF)
+iflag_mix=0
+#weights of the bell shaped and flat PDF (used only if iflag_mix=1) (D: 1 0)
+qqa1=1.
+qqa2=0.
+#Parameters of the bell shaped PDF; Fmax=center (D= 0.65), Gammas=width (D=0.05)
+cvl_corr=1.0
+#Multiplicative factor of Emanuel convective scheme precipitation (D: 1.)
+Fmax=0.65
+#
+# Flags Couche limite
+#********************
+#shema de CL des thermiques (D:0, 0:ajustement sec,=>1:versions thermiques) 
+iflag_thermals=18
+#pas de temps du spliting pour les thermiques
+nsplit_thermals=1
+tau_thermals=0.
+iflag_thermals_ed=8
+fact_thermals_ed_dz=0.1
+iflag_thermals_optflux=0
+#shema de la couche de surface (D:1, 1:LMD, 8:Mellor-Yamada) 
+iflag_pbl=11
+#diffusion turbulente
+ksta_ter=1.e-7
+ksta=1.e-10
+#ok_kzmin : calcul Kzmin dans la CL de surface
+ok_kzmin=y
+#couplage ou non avec la convection
+iflag_coupl=5 (0:AR4 et 1:nouvelle physique)
+seuil_inversion=-0.08
+#rendement sur la puissance fournie par les thermiques a la convection
+alp_bl_k=0.5
+#
+## temperature dependency of qsat for iterative procedure
+## temporary flag to switch between the old (CMIP5, D=0) and new versions (=1) versions 
+iflag_fisrtilp_qsat=4 
+## Reactivation du calcul d'un zmax continu pour les thermiques
+## reactivation d'une fermeture humide des thermiques  iflag_thermals_closure=2 (D=1)
+iflag_thermals_closure=1
+#
+# Flags wakes
+#************
+#Wake scheme switch (D:0, 0:AR4, 1:New Physics)
+iflag_wake=1
+#Constant value to be added to Alp (D: 0.)
+alp_offset=0.
+
+### nrlmd le 10/04/2012: Declenchement ###
+#Déclelenchement par couche-limite (0: deterministe, 1: stochastique)
+iflag_trig_bl=1
+#Surface critique au LCL
+s_trig=1.2e7
+#Temps de decorrelation entre scenes de cumulus
+tau_trig_shallow=1200
+#Temps de decorrelation entre scenes de cumulonimbus
+tau_trig_deep=1200
+# Pour la stabilisation
+random_notrig_max=0.99
+ok_adjwk=y
+tmax_fonte_cv=288.15
+
+
+### nrlmd le 10/04/2012: Fermeture ###
+#Fermeture par couche-limite (0: deterministe, 1: statistique, 2: statistique+convergence grande échelle)
+iflag_clos_bl=1
+### fin nrlmd le 10/04/2012
+
+## Modification de la plage de temperature pour la phase mixte liquide/glace des nuages
+## Controle par les t_glace_min/max, exposant_glace, iflag_t_glace (D=0)
+t_glace_min=233.13
+t_glace_max=273.13
+exposant_glace=1.
+iflag_t_glace=1
+iflag_ice_thermo=1
+
+#
+## The source terms of the TKE prognostic equation are diagnosed from tendencies (du, dv, dT) 
+## associated with subrgrid scaleamotions and treated as an additional heat source.
+## Controled by a key, iflag_ener_conserv (D=-1):
+## 0 : no conservation, -1 : old adhoc correction for kinetic E only (used for CMIP5) 
+## 1 : conservation, 101 : conversion from kinetic to heat only, 110 conversion from potential to heat only
+iflag_ener_conserv=1
+
+#Activation of corrections for water conservation (D: n). 
+##The default is n for compatibility with earlier versions.
+##generally it should be y.
+ok_conserv_q=y 
Index: /LMDZ5/branches/testing/arch/arch-X64_OCCIGEN.fcm
===================================================================
--- /LMDZ5/branches/testing/arch/arch-X64_OCCIGEN.fcm	(revision 2408)
+++ /LMDZ5/branches/testing/arch/arch-X64_OCCIGEN.fcm	(revision 2408)
@@ -0,0 +1,15 @@
+%COMPILER            mpif90
+%LINK                mpif90
+%AR                  ar
+%MAKE                gmake
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             NC_DOUBLE FFT_MKL
+%BASE_FFLAGS         -i4 -r8 -auto -recursive -mcmodel=medium -align all -fp-model strict -xCORE-AVX2
+%PROD_FFLAGS         -O2 -ip
+%DEV_FFLAGS          -p -g -O1 -fpe0 -traceback
+%DEBUG_FFLAGS        -p -g -O0 -fpe-all=0 -ftz -ftrapuv -fp-stack-check -check all -debug -traceback
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp -openmp-threadprivate compat
+%BASE_LD             -i4 -r8 -auto -shared-intel -Wl,-rpath=/opt/software/libraries/netcdf/bullxmpi/netcdf-4.3.3-rc2/lib:/opt/software/libraries/netcdf/bullxmpi/netcdf-fortran-4.4.1-4.3.3-rc2/lib:/opt/software/libraries/hdf5/hdf5_with_bullxmpi/1.8.14/lib $MKL_LIBS
+%MPI_LD
+%OMP_LD              -openmp
Index: /LMDZ5/branches/testing/arch/arch-X64_OCCIGEN.path
===================================================================
--- /LMDZ5/branches/testing/arch/arch-X64_OCCIGEN.path	(revision 2408)
+++ /LMDZ5/branches/testing/arch/arch-X64_OCCIGEN.path	(revision 2408)
@@ -0,0 +1,13 @@
+NETCDF_LIBDIR="-L/opt/software/libraries/netcdf/bullxmpi/netcdf-fortran-4.4.1-4.3.3-rc2/lib -lnetcdff -L/opt/software/libraries/netcdf/bullxmpi/netcdf-4.3.3-rc2/lib -lnetcdf -L/opt/software/libraries/hdf5/hdf5_with_bullxmpi/1.8.14/lib -lhdf5_hl -lhdf5 -lz"
+NETCDF_INCDIR="-I/opt/software/libraries/hdf5/hdf5_with_bullxmpi/1.8.14/include -I/opt/software/libraries/netcdf/bullxmpi/netcdf-fortran-4.4.1-4.3.3-rc2/include"
+IOIPSL_INCDIR=$LMDGCM/../../lib
+IOIPSL_LIBDIR=$LMDGCM/../../lib
+XIOS_INCDIR=$LMDGCM/../XIOS/inc
+XIOS_LIBDIR=$LMDGCM/../XIOS/lib
+ORCH_INCDIR=$LMDGCM/../../lib
+ORCH_LIBDIR=$LMDGCM/../../lib
+OASIS_INCDIR=$LMDGCM/../../oasis3-mct/BLD/build/lib/psmile.MPI1
+OASIS_LIBDIR=$LMDGCM/../../oasis3-mct/BLD/lib
+INCA_LIBDIR=$LMDGCM/../INCA/config/lib
+INCA_INCDIR=$LMDGCM/../INCA/config/inc
+
Index: /LMDZ5/branches/testing/bld.cfg
===================================================================
--- /LMDZ5/branches/testing/bld.cfg	(revision 2407)
+++ /LMDZ5/branches/testing/bld.cfg	(revision 2408)
@@ -32,4 +32,5 @@
 src::misc    %SRC_PATH/misc
 src::dyn3d_common   %DYN_COMMON 
+src::phy_common %PHY_COMMON
 src::cosp    %COSP
 src::ext_src %EXT_SRC
@@ -37,12 +38,11 @@
 bld::lib            lmdz
 
-bld::outfile_ext::exe    %SUFF_NAME.e
-bld::target              liblmdz.a 
-bld::target              %EXEC%SUFF_NAME.e
+bld::outfile_ext::exe    %SUFF_NAME
+bld::target              liblmdz.a %EXEC%SUFF_NAME
 bld::exe_dep             
 
 
 dir::root            %CONFIG_PATH
-dir::lib             %BASE_CONFIG_PATH
+#dir::lib             %BASE_CONFIG_PATH
 dir::bin             %ROOT_PATH/bin
 
Index: /LMDZ5/branches/testing/create_make_gcm
===================================================================
--- /LMDZ5/branches/testing/create_make_gcm	(revision 2407)
+++ /LMDZ5/branches/testing/create_make_gcm	(revision 2408)
@@ -54,4 +54,5 @@
 echo "PHYS  = "
 echo 'LIBPHY = $(LIBO)/libphy$(PHYS).a'
+echo 'LIBPHY_COMMON= $(LIBO)/libphy_common.a'
 echo 'LIBDYN_PHY = $(LIBO)/libdynlmdz_phy$(PHYS).a'
 echo 'DIRMAIN=dyn$(DIM)d$(FLAG_PARA)'
@@ -64,5 +65,5 @@
 echo 'L_FILTRE   = -l$(FILTRE)'
 echo 'L_DYN_PHY = -ldynlmdz_phy$(PHYS) '
-echo 'L_PHY = -lphy$(PHYS) '
+echo 'L_PHY = -lphy$(PHYS) -lphy_common'
 echo 'L_MISC    = -lmisc'
 echo 'L_ADJNT    ='
@@ -92,5 +93,5 @@
 echo
 #echo 'main : chimie $(DYN) misc phys $(OPTION_DEP) '
-echo 'main : $(DYN) misc phys dyn_phy $(OPTION_DEP) '
+echo 'main : $(DYN) misc phys phy_common dyn_phy $(OPTION_DEP) '
 echo '	cd $(LIBO) ; $(RANLIB) lib*.a ; cd $(GCM) ;\'
 echo '	cd $(LOCAL_DIR); \'
@@ -99,4 +100,5 @@
 echo
 echo 'phys : $(LIBPHY)'
+echo 'phy_common : $(LIBPHY_COMMON)'
 echo 'dyn3d : $(LIBO)/libdyn$(DIM)d$(FLAG_PARA).a $(LIBO)/lib$(FILTRE).a $(LIBO)/libdyn3d_common.a'
 echo 'dyn2d : $(LIBO)/libdyn2d.a'
Index: /LMDZ5/branches/testing/libf/dyn3d/dynetat0.f90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d/dynetat0.f90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d/dynetat0.f90	(revision 2408)
@@ -0,0 +1,202 @@
+SUBROUTINE dynetat0(fichnom,vcov,ucov,teta,q,masse,ps,phis,time)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , L.Fairhead
+!-------------------------------------------------------------------------------
+! Purpose: Initial state reading.
+!-------------------------------------------------------------------------------
+  USE infotrac
+  USE netcdf,      ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_INQ_VARID, NF90_NoErr, &
+                         NF90_CLOSE, NF90_GET_VAR
+  USE control_mod, ONLY: planet_type
+  USE assert_eq_m, ONLY: assert_eq
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "temps.h"
+  include "comconst.h"
+  include "comvert.h"
+  include "comgeom2.h"
+  include "ener.h"
+  include "description.h"
+  include "serre.h"
+  include "logic.h"
+  include "iniprint.h"
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+  REAL, INTENT(OUT) ::  vcov(iip1,jjm, llm)        !--- V COVARIANT WIND
+  REAL, INTENT(OUT) ::  ucov(iip1,jjp1,llm)        !--- U COVARIANT WIND
+  REAL, INTENT(OUT) ::  teta(iip1,jjp1,llm)        !--- POTENTIAL TEMP.
+  REAL, INTENT(OUT) ::     q(iip1,jjp1,llm,nqtot)  !--- TRACERS
+  REAL, INTENT(OUT) :: masse(iip1,jjp1,llm)        !--- MASS PER CELL
+  REAL, INTENT(OUT) ::    ps(iip1,jjp1)            !--- GROUND PRESSURE
+  REAL, INTENT(OUT) ::  phis(iip1,jjp1)            !--- GEOPOTENTIAL
+!===============================================================================
+! Local variables:
+  CHARACTER(LEN=256) :: msg, var, modname
+  INTEGER, PARAMETER :: length=100
+  INTEGER :: iq, fID, vID, idecal!, iml, jml, lml, nqt
+  REAL    :: time, tab_cntrl(length)               !--- RUN PARAMS TABLE
+!-------------------------------------------------------------------------------
+  modname="dynetat0"
+
+!--- Initial state file opening
+  var=fichnom
+  CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
+  CALL get_var1("controle",tab_cntrl)
+
+!!! AS: idecal is a hack to be able to read planeto starts...
+!!!     .... while keeping everything OK for LMDZ EARTH
+  IF(planet_type=="generic") THEN
+    WRITE(lunout,*)'NOTE NOTE NOTE : Planeto-like start files'
+    idecal = 4
+    annee_ref  = 2000
+  ELSE
+    WRITE(lunout,*)'NOTE NOTE NOTE : Earth-like start files'
+    idecal = 5
+    annee_ref  = tab_cntrl(5)
+  END IF
+  im         = tab_cntrl(1)
+  jm         = tab_cntrl(2)
+  lllm       = tab_cntrl(3)
+  day_ref    = tab_cntrl(4)
+  rad        = tab_cntrl(idecal+1)
+  omeg       = tab_cntrl(idecal+2)
+  g          = tab_cntrl(idecal+3)
+  cpp        = tab_cntrl(idecal+4)
+  kappa      = tab_cntrl(idecal+5)
+  daysec     = tab_cntrl(idecal+6)
+  dtvr       = tab_cntrl(idecal+7)
+  etot0      = tab_cntrl(idecal+8)
+  ptot0      = tab_cntrl(idecal+9)
+  ztot0      = tab_cntrl(idecal+10)
+  stot0      = tab_cntrl(idecal+11)
+  ang0       = tab_cntrl(idecal+12)
+  pa         = tab_cntrl(idecal+13)
+  preff      = tab_cntrl(idecal+14)
+!
+  clon       = tab_cntrl(idecal+15)
+  clat       = tab_cntrl(idecal+16)
+  grossismx  = tab_cntrl(idecal+17)
+  grossismy  = tab_cntrl(idecal+18)
+!
+  IF ( tab_cntrl(idecal+19)==1. )  THEN
+    fxyhypb  = .TRUE.
+!   dzoomx   = tab_cntrl(25)
+!   dzoomy   = tab_cntrl(26)
+!   taux     = tab_cntrl(28)
+!   tauy     = tab_cntrl(29)
+  ELSE
+    fxyhypb = .FALSE.
+    ysinus  = tab_cntrl(idecal+22)==1.
+  END IF
+
+  day_ini    = tab_cntrl(30)
+  itau_dyn   = tab_cntrl(31)
+  start_time = tab_cntrl(32)
+
+!-------------------------------------------------------------------------------
+  WRITE(lunout,*)TRIM(modname)//': rad,omeg,g,cpp,kappa',rad,omeg,g,cpp,kappa
+  CALL check_dim(im,iim,'im','im')
+  CALL check_dim(jm,jjm,'jm','jm')
+  CALL check_dim(lllm,llm,'lm','lllm')
+  CALL get_var1("rlonu",rlonu)
+  CALL get_var1("rlatu",rlatu)
+  CALL get_var1("rlonv",rlonv)
+  CALL get_var1("rlatv",rlatv)
+  CALL get_var2("cu"   ,cu)
+  CALL get_var2("cv"   ,cv)
+  CALL get_var2("aire" ,aire)
+  var="temps"
+  IF(NF90_INQ_VARID(fID,var,vID)/=NF90_NoErr) THEN
+    WRITE(lunout,*)TRIM(modname)//": missing field <temps>"
+    WRITE(lunout,*)TRIM(modname)//": trying with <Time>"; var="Time"
+    CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  END IF
+  CALL err(NF90_GET_VAR(fID,vID,time),"get",var)
+  CALL get_var2("phisinit",phis)
+  CALL get_var3("ucov",ucov)
+  CALL get_var3("vcov",vcov)
+  CALL get_var3("teta",teta)
+  CALL get_var3("masse",masse)
+  CALL get_var2("ps",ps)
+
+!--- Tracers
+  DO iq=1,nqtot
+    var=tname(iq)
+    IF(NF90_INQ_VARID(fID,var,vID)==NF90_NoErr) THEN
+      CALL err(NF90_GET_VAR(fID,vID,q(:,:,:,iq)),"get",var); CYCLE
+    END IF
+    WRITE(lunout,*)TRIM(modname)//": Tracer <"//TRIM(var)//"> is missing"
+    WRITE(lunout,*)"         It is hence initialized to zero"
+    q(:,:,:,iq)=0.
+   !--- CRisi: for isotops, theoretical initialization using very simplified
+   !           Rayleigh distillation las.
+    IF(ok_isotopes.AND.iso_num(iq)>0) THEN
+      IF(zone_num(iq)==0) q(:,:,:,iq)=q(:,:,:,iqpere(iq))*tnat(iso_num(iq))    &
+     &             *(q(:,:,:,iqpere(iq))/30.e-3)**(alpha_ideal(iso_num(iq))-1)
+      IF(zone_num(iq)==1) q(:,:,:,iq)=q(:,:,:,iqiso(iso_indnum(iq),phase_num(iq)))
+    END IF
+  END DO
+
+  CALL err(NF90_CLOSE(fID),"close",fichnom)
+  day_ini=day_ini+INT(time)
+  time=time-INT(time)
+
+
+  CONTAINS
+
+
+SUBROUTINE check_dim(n1,n2,str1,str2)
+  INTEGER,          INTENT(IN) :: n1, n2
+  CHARACTER(LEN=*), INTENT(IN) :: str1, str2
+  CHARACTER(LEN=256) :: s1, s2
+  IF(n1/=n2) THEN
+    s1='value of '//TRIM(str1)//' ='
+    s2=' read in starting file differs from parametrized '//TRIM(str2)//' ='
+    WRITE(msg,'(10x,a,i4,2x,a,i4)'),s1,n1,s2,n2
+    CALL ABORT_gcm(TRIM(modname),TRIM(msg),1)
+  END IF
+END SUBROUTINE check_dim
+
+
+SUBROUTINE get_var1(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var1
+
+
+SUBROUTINE get_var2(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var2
+
+
+SUBROUTINE get_var3(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var3
+
+
+SUBROUTINE err(ierr,typ,nam)
+  INTEGER,          INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD/FILE NAME
+  IF(ierr==NF90_NoERR) RETURN
+  SELECT CASE(typ)
+    CASE('inq');   msg="Field <"//TRIM(nam)//"> is missing"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('open');  msg="File opening failed for <"//TRIM(nam)//">"
+    CASE('close'); msg="File closing failed for <"//TRIM(nam)//">"
+  END SELECT
+  CALL ABORT_gcm(TRIM(modname),TRIM(msg),ierr)
+END SUBROUTINE err
+
+END SUBROUTINE dynetat0
Index: /LMDZ5/branches/testing/libf/dyn3d/dynredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3d/dynredem.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/dyn3d/dynredem.F90	(revision 2408)
@@ -0,0 +1,247 @@
+SUBROUTINE dynredem0(fichnom,iday_end,phis)
+!
+!-------------------------------------------------------------------------------
+! Write the NetCDF restart file (initialization).
+!-------------------------------------------------------------------------------
+#ifdef CPP_IOIPSL
+  USE IOIPSL
+#endif
+  USE infotrac
+  USE netcdf, ONLY: NF90_CREATE, NF90_DEF_DIM, NF90_INQ_VARID, NF90_GLOBAL,    &
+                    NF90_CLOSE,  NF90_PUT_ATT, NF90_UNLIMITED, NF90_CLOBBER
+  USE dynredem_mod, ONLY: cre_var, put_var1, put_var2, err, modname, fil
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comvert.h"
+  include "comgeom2.h"
+  include "temps.h"
+  include "ener.h"
+  include "logic.h"
+  include "description.h"
+  include "serre.h"
+  include "iniprint.h"
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+  INTEGER,          INTENT(IN) :: iday_end         !--- 
+  REAL,             INTENT(IN) :: phis(iip1, jjp1) !--- GROUND GEOPOTENTIAL
+!===============================================================================
+! Local variables:
+  INTEGER :: iq, l
+  INTEGER, PARAMETER :: length=100
+  REAL    :: tab_cntrl(length)                     !--- RUN PARAMETERS TABLE
+!   For NetCDF:
+  CHARACTER(LEN=30) :: unites
+  INTEGER :: indexID
+  INTEGER :: rlonuID, rlonvID, rlatuID, rlatvID
+  INTEGER :: sID, sigID, nID, vID, timID
+  INTEGER :: yyears0, jjour0, mmois0
+  REAL    :: zan0, zjulian, hours
+!===============================================================================
+  modname='dynredem0'; fil=fichnom
+#ifdef CPP_IOIPSL
+  CALL ymds2ju(annee_ref, 1, iday_end, 0.0, zjulian)
+  CALL ju2ymds(zjulian, yyears0, mmois0, jjour0, hours)
+#else
+! set yyears0, mmois0, jjour0 to 0,1,1 (hours is not used)
+  yyears0=0
+  mmois0=1
+  jjour0=1
+#endif        
+
+  tab_cntrl(:)  = 0.
+  tab_cntrl(1)  = REAL(iim)
+  tab_cntrl(2)  = REAL(jjm)
+  tab_cntrl(3)  = REAL(llm)
+  tab_cntrl(4)  = REAL(day_ref)
+  tab_cntrl(5)  = REAL(annee_ref)
+  tab_cntrl(6)  = rad
+  tab_cntrl(7)  = omeg
+  tab_cntrl(8)  = g
+  tab_cntrl(9)  = cpp
+  tab_cntrl(10) = kappa
+  tab_cntrl(11) = daysec
+  tab_cntrl(12) = dtvr
+  tab_cntrl(13) = etot0
+  tab_cntrl(14) = ptot0
+  tab_cntrl(15) = ztot0
+  tab_cntrl(16) = stot0
+  tab_cntrl(17) = ang0
+  tab_cntrl(18) = pa
+  tab_cntrl(19) = preff
+
+!    .....    parameters for zoom    ......   
+  tab_cntrl(20) = clon
+  tab_cntrl(21) = clat
+  tab_cntrl(22) = grossismx
+  tab_cntrl(23) = grossismy
+!
+  IF ( fxyhypb )   THEN
+    tab_cntrl(24) = 1.
+    tab_cntrl(25) = dzoomx
+    tab_cntrl(26) = dzoomy
+    tab_cntrl(27) = 0.
+    tab_cntrl(28) = taux
+    tab_cntrl(29) = tauy
+  ELSE
+    tab_cntrl(24) = 0.
+    tab_cntrl(25) = dzoomx
+    tab_cntrl(26) = dzoomy
+    tab_cntrl(27) = 0.
+    tab_cntrl(28) = 0.
+    tab_cntrl(29) = 0.
+    IF( ysinus )  tab_cntrl(27) = 1.
+  END IF
+  tab_cntrl(30) = REAL(iday_end)
+  tab_cntrl(31) = REAL(itau_dyn + itaufin)
+! start_time: start_time of simulation (not necessarily 0.)
+  tab_cntrl(32) = start_time
+
+!--- File creation
+  CALL err(NF90_CREATE(fichnom,NF90_CLOBBER,nid))
+
+!--- Some global attributes
+  CALL err(NF90_PUT_ATT(nid,NF90_GLOBAL,"title","Fichier demarrage dynamique"))
+
+!--- Dimensions
+  CALL err(NF90_DEF_DIM(nid,"index", length, indexID))
+  CALL err(NF90_DEF_DIM(nid,"rlonu", iip1,   rlonuID))
+  CALL err(NF90_DEF_DIM(nid,"rlatu", jjp1,   rlatuID))
+  CALL err(NF90_DEF_DIM(nid,"rlonv", iip1,   rlonvID))
+  CALL err(NF90_DEF_DIM(nid,"rlatv", jjm,    rlatvID))
+  CALL err(NF90_DEF_DIM(nid,"sigs",  llm,        sID))
+  CALL err(NF90_DEF_DIM(nid,"sig",   llmp1,    sigID))
+  CALL err(NF90_DEF_DIM(nid,"temps", NF90_UNLIMITED, timID))
+
+!--- Define and save invariant fields
+  CALL put_var1(nid,"controle","Parametres de controle" ,[indexID],tab_cntrl)
+  CALL put_var1(nid,"rlonu"   ,"Longitudes des points U",[rlonuID],rlonu)
+  CALL put_var1(nid,"rlatu"   ,"Latitudes des points U" ,[rlatuID],rlatu)
+  CALL put_var1(nid,"rlonv"   ,"Longitudes des points V",[rlonvID],rlonv)
+  CALL put_var1(nid,"rlatv"   ,"Latitudes des points V" ,[rlatvID],rlatv)
+  CALL put_var1(nid,"nivsigs" ,"Numero naturel des couches s"    ,[sID]  ,nivsigs)
+  CALL put_var1(nid,"nivsig"  ,"Numero naturel des couches sigma",[sigID],nivsig)
+  CALL put_var1(nid,"ap"      ,"Coefficient A pour hybride"      ,[sigID],ap)
+  CALL put_var1(nid,"bp"      ,"Coefficient B pour hybride"      ,[sigID],bp)
+  CALL put_var1(nid,"presnivs",""                                ,[sID]  ,presnivs)
+! covariant <-> contravariant <-> natural conversion coefficients
+  CALL put_var2(nid,"cu","Coefficient de passage pour U",[rlonuID,rlatuID],cu)
+  CALL put_var2(nid,"cv","Coefficient de passage pour V",[rlonvID,rlatvID],cv)
+  CALL put_var2(nid,"aire","Aires de chaque maille"     ,[rlonvID,rlatuID],aire)
+  CALL put_var2(nid,"phisinit","Geopotentiel au sol"    ,[rlonvID,rlatuID],phis)
+
+!--- Define fields saved later
+  WRITE(unites,"('days since ',i4,'-',i2.2,'-',i2.2,' 00:00:00')"),&
+               yyears0,mmois0,jjour0
+  CALL cre_var(nid,"temps","Temps de simulation",[timID],unites)
+  CALL cre_var(nid,"ucov" ,"Vitesse U"  ,[rlonuID,rlatuID,sID,timID])
+  CALL cre_var(nid,"vcov" ,"Vitesse V"  ,[rlonvID,rlatvID,sID,timID])
+  CALL cre_var(nid,"teta" ,"Temperature",[rlonvID,rlatuID,sID,timID])
+  DO iq=1,nqtot
+    CALL cre_var(nid,tname(iq),ttext(iq),[rlonvID,rlatuID,sID,timID])
+  END DO
+  CALL cre_var(nid,"masse","Masse d air"    ,[rlonvID,rlatuID,sID,timID])
+  CALL cre_var(nid,"ps"   ,"Pression au sol",[rlonvID,rlatuID    ,timID])
+  CALL err(NF90_CLOSE (nid))
+
+  WRITE(lunout,*)TRIM(modname)//': iim,jjm,llm,iday_end',iim,jjm,llm,iday_end
+  WRITE(lunout,*)TRIM(modname)//': rad,omeg,g,cpp,kappa',rad,omeg,g,cpp,kappa
+
+END SUBROUTINE dynredem0
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE dynredem1(fichnom,time,vcov,ucov,teta,q,masse,ps)
+!
+!-------------------------------------------------------------------------------
+! Purpose: Write the NetCDF restart file (append).
+!-------------------------------------------------------------------------------
+  USE infotrac
+  USE control_mod
+  USE netcdf,   ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_GET_VAR, NF90_INQ_VARID,  &
+                      NF90_CLOSE, NF90_WRITE,   NF90_PUT_VAR, NF90_NoErr
+  USE dynredem_mod, ONLY: dynredem_write_u, dynredem_write_v, dynredem_read_u, &
+                          err, modname, fil, msg
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "description.h"
+  include "comvert.h"
+  include "comgeom.h"
+  include "temps.h"
+  include "iniprint.h"
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom              !-- FILE NAME
+  REAL, INTENT(IN)    ::  time                         !-- TIME
+  REAL, INTENT(IN)    ::  vcov(iip1,jjm, llm)          !-- V COVARIANT WIND
+  REAL, INTENT(IN)    ::  ucov(iip1,jjp1,llm)          !-- U COVARIANT WIND
+  REAL, INTENT(IN)    ::  teta(iip1,jjp1,llm)          !-- POTENTIAL TEMPERATURE
+  REAL, INTENT(INOUT) ::     q(iip1,jjp1,llm,nqtot)    !-- TRACERS
+  REAL, INTENT(IN)    :: masse(iip1,jjp1,llm)          !-- MASS PER CELL
+  REAL, INTENT(IN)    ::    ps(iip1,jjp1)              !-- GROUND PRESSURE
+!===============================================================================
+! Local variables:
+  INTEGER :: l, iq, nid, vID, ierr, nid_trac, vID_trac
+  INTEGER, SAVE :: nb=0
+  INTEGER, PARAMETER :: length=100
+  REAL               :: tab_cntrl(length) ! tableau des parametres du run
+  CHARACTER(LEN=256) :: var, dum
+  LOGICAL            :: lread_inca
+!===============================================================================
+
+  modname='dynredem1'; fil=fichnom
+  CALL err(NF90_OPEN(fil,NF90_WRITE,nid),"open",fil)
+
+!--- Write/extend time coordinate
+  nb = nb + 1
+  var="temps"
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_PUT_VAR(nid,vID,[time]),"put",var)
+  WRITE(lunout,*)TRIM(modname)//": Saving for ", nb, time
+
+!--- Rewrite control table (itaufin undefined in dynredem0)
+  var="controle"
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(nid,vID,tab_cntrl),"get",var)
+  tab_cntrl(31)=DBLE(itau_dyn + itaufin)
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_PUT_VAR(nid,vID,tab_cntrl),"put",var)
+
+!--- Save fields
+  CALL dynredem_write_u(nid,"ucov" ,ucov ,llm)
+  CALL dynredem_write_v(nid,"vcov" ,vcov ,llm)
+  CALL dynredem_write_u(nid,"teta" ,teta ,llm)
+  CALL dynredem_write_u(nid,"masse",masse,llm)
+  CALL dynredem_write_u(nid,"ps"   ,ps   ,1)
+
+!--- Tracers in file "start_trac.nc" (added by Anne)
+  lread_inca=.FALSE.; fil="start_trac.nc"
+  IF(type_trac=='inca') INQUIRE(FILE=fil,EXIST=lread_inca)
+  IF(lread_inca) CALL err(NF90_OPEN(fil,NF90_NOWRITE,nid_trac),"open")
+
+!--- Save tracers
+  DO iq=1,nqtot; var=tname(iq); ierr=-1
+    IF(lread_inca) THEN                  !--- Possibly read from "start_trac.nc"
+      fil="start_trac.nc"
+      ierr=NF90_INQ_VARID(nid_trac,var,vID_trac)
+      dum='inq'; IF(ierr==NF90_NoErr) dum='fnd'
+      WRITE(lunout,*)msg(dum,var)
+
+
+      IF(ierr==NF90_NoErr) CALL dynredem_read_u(nid_trac,var,q(:,:,:,iq),llm)
+    END IF
+    fil=fichnom
+    CALL dynredem_write_u(nid,var,q(:,:,:,iq),llm)
+  END DO
+  CALL err(NF90_CLOSE(nid),"close")
+  fil="start_trac.nc"
+  IF(lread_inca) CALL err(NF90_CLOSE(nid_trac),"close")
+
+END SUBROUTINE dynredem1
+
